with Ada.Text_IO; use Ada.Text_IO;
with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;

procedure MainPersonne is
   type Personne is record
      Nom : String (1 .. 6);
      Age : Integer;
      Homme : Boolean;
   end record;

   procedure Put (P : in Personne) is
   begin
      Put (P.Nom); Put (" ");
      Put (P.Age, 0); Put (" ");
      if P.Homme then
         Put ("M");
      else
         Put ("F");
      end if;
   end Put;
   
   Age_Incorrect : exception;
   Sexe_Inconnu : exception;
   
   procedure Get (P : out Personne) is
      Sexe : Character;
   begin
      Get (P.Nom);
      Get (P.Age);
      if P.Age < 0 then
	 raise Age_Incorrect;
      end if;
      Get (Sexe);
      if Sexe = 'M' then
	 P.Homme := True;
      elsif Sexe = 'F' then
	 P.Homme := False;
      else
	 raise Sexe_Inconnu;
      end if;
   end;

   P : Personne;
begin
   P := ("Dupont", 23, True);
   Put (P); New_Line;

   P.Age := 15;
   P.Homme := False;
   Put (P); New_Line;

   P := (Homme => True, Age => 14, Nom => "Durand");
   Put (P); New_Line;
   
   Put ("Saisir une personne (Nom : 6 caracteres, Age, Sexe M ou F) > ");
   --Get (P);
   --Put (P);
   
   declare
      Fin : Boolean := False;
   begin
      while not Fin loop
	 begin
	    Get (P);
	    Fin := True;
	 exception
	    when DATA_ERROR | Age_Incorrect | Sexe_Inconnu =>
	       Put_Line ("Saisie incorrecte !");
	       Put ("Saisir une personne (Nom : 6 caracteres, Age, Sexe M ou F) > ");
	 end;
      end loop;
   end;
   Put (P);
   
exception
   when Age_Incorrect =>
      Put_Line ("Un age incorrect a été saisi");
      Put_Line ("Le programme ne peut pas poursuivre son exécution");
      
   when Sexe_Inconnu =>
      Put_Line ("Le sexe doit être M ou F");
      Get (P); Put (P);
            
--   when others => Put_Line ("FATAL ERROR : UNKNOWN EXCEPTION !!!!!!");
end MainPersonne;
