with Ada.Text_IO; use Ada.Text_IO;
with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;

procedure MainPersonne_V2 is
   type Personne is record
      Nom : String (1 .. 6);
      Age : Integer;
      Homme : Boolean;
   end record;

   procedure Put (P : in Personne) is
   begin
      Put (P.Nom); Put (" ");
      Put (P.Age, 0); Put (" ");
      if P.Homme then
         Put ("M");
      else
         Put ("F");
      end if;
   end Put;
   
   Saisie_Incorrecte : exception;
   
   procedure Get (P : out Personne) is
      Sexe : Character;
   begin
      Get (P.Nom);
      begin
	 Get (P.Age);
	 if P.Age < 0 then
	    raise Saisie_Incorrecte;
	 end if;
      exception
	 when DATA_ERROR => Put_Line ("DATA_ERROR..."); Raise Saisie_Incorrecte;
      end;
      Get (Sexe);
      if Sexe = 'M' then
	 P.Homme := True;
      elsif Sexe = 'F' then
	 P.Homme := False;
      else
	 raise Saisie_Incorrecte;
      end if;
   end;

   P : Personne;
begin
   P := ("Dupont", 23, True);
   Put (P); New_Line;

   P.Age := 15;
   P.Homme := False;
   Put (P); New_Line;

   P := (Homme => True, Age => 14, Nom => "Durand");
   Put (P); New_Line;
   
   Put ("Saisir une personne (Nom : 6 caracteres, Age, Sexe M ou F) > ");
   
   declare
      Fin : Boolean := False;
   begin
      while not Fin loop
	 begin
	    Get (P);
	    Fin := True;
	 exception
	    when Saisie_Incorrecte =>
	       Put_Line ("Saisie incorrecte !");
	       Put ("Saisir une personne (Nom : 6 caracteres, Age, Sexe M ou F) > ");
	 end;
      end loop;
   end;
   
   Put ("La personne saisie est : ");
   Put (P);
end MainPersonne_V2;
